prologin/contest/urls.py
from django.urls import path, include
import contest.views
import contest.staff_views
import contest.interschool_views

app_name = 'contest'

correction_patterns = [
    path('', contest.staff_views.IndexView.as_view(), name='index'),
    path('<int:year>', contest.staff_views.YearIndexView.as_view(), name='year'),
    path('<int:year>/qualification', contest.staff_views.QualificationIndexView.as_view(), name='qualification'),
    path('<int:year>/semifinal', contest.staff_views.SemifinalIndexView.as_view(), name='semifinal'),
    path('<int:year>/semifinal/<int:event>', contest.staff_views.SemifinalEventIndexView.as_view(), name='semifinal'),
    path('<int:year>/final', contest.staff_views.FinalIndexView.as_view(), name='final'),
    path('<int:year>/<int:cid>/qualification', contest.staff_views.ContestantQualificationView.as_view(), name='contestant-qualification'),
    path('<int:year>/<int:cid>/semifinal', contest.staff_views.ContestantSemifinalView.as_view(), name='contestant-semifinal'),
    path('<int:year>/<int:cid>/live/<type>', contest.staff_views.ContestantLiveUpdate.as_view(), name='live-update'),
]

interschool_patterns = [
    path('leaderboard', contest.interschool_views.LeaderboardView.as_view(), name='leaderboard'),
]

urlpatterns = [
    path('<int:year>/qualification', contest.views.QualificationSummary.as_view(), name='qualification-summary'),
    path('inter-school-challenge/', include((interschool_patterns, app_name), namespace='interschool')),
    path('correct/', include((correction_patterns, app_name), namespace='correction')),
]

prologin/pages/urls.py
from django.urls import path
from pages import views

app_name = 'pages'

urlpatterns = [
    path('about/contest', views.AboutContestView.as_view(), name='about-contest'),
    path('about/contest/qualification', views.AboutQualificationView.as_view(), name='about-qualification'),
    path('about/contest/semifinals', views.AboutSemifinalsView.as_view(), name='about-semifinals'),
    path('about/contest/final', views.AboutFinalView.as_view(), name='about-final'),
    path('about/contest/history', views.AboutHistoryView.as_view(), name='about-history'),
    path('about/organization', views.AboutOrganizationView.as_view(), name='about-organization'),
    path('about/contest-rules', views.AboutContestRulesView.as_view(), name='about-contest-rules'),
    path('about/contribute', views.AboutContributeView.as_view(), name='about-contribute'),
    path('about/privacy', views.AboutPrivacyPolicyView.as_view(), name='about-privacy-policy'),
]

prologin/prologin/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.http import HttpResponse
from django.urls import path, include
from django.views.generic.base import TemplateView

import debug_toolbar

from homepage.views import HomepageView


def crash_test(request):
    if request.user.is_authenticated:
        1 / 0
    return HttpResponse(status=204)


urlpatterns = [
    # Debug toolbar
    path('__debug__/', include(debug_toolbar.urls)),

    # Homepage
    path('', HomepageView.as_view(), name='home'),

    # Built-in Django admin
    path('admin/', admin.site.urls),

    # Captcha
    path('captcha/', include('captcha.urls')),

    # Hijack
    path('hijack/', include('hijack.urls', namespace='hijack')),

    # Language selector
    path('lang/', include('django.conf.urls.i18n')),

    # News (blog)
    path('news/', include('news.urls')),

    # Forum
    path('forum/', include('forum.urls', namespace='forum')),

    # Teams
    path('team/', include('team.urls', namespace='team')),

    # Centers
    path('center/', include('centers.urls', namespace='centers')),

    # Documents
    path('docs/', include('documents.urls', namespace='documents')),

    # Archives
    path('archives/', include('archives.urls', namespace='archives')),

    # Contest
    path('contest/<int:year>/qualification/quiz/', include('qcm.urls', namespace='qcm')),
    path('contest/', include('contest.urls', namespace='contest')),

    # Training
    path('train/', include('problems.urls', namespace='problems')),

    # Authentication and accounts
    path('user/', include('users.urls', namespace='users')),

    # Mailing
    path('mailing/', include('massmailer.urls', namespace='massmailer')),

    # Schools
    path('schools/', include('schools.urls', namespace='schools')),

    # Sponsors
    path('sponsors/', include('sponsor.urls', namespace='sponsors')),

    # Crash test
    path('crashtest/', crash_test),

    # Pages
    path('', include('pages.urls', namespace='pages')),

    # Monitoring
    path('', include('django_prometheus.urls')),
]

if 'oidc_provider' in settings.INSTALLED_APPS and 'oidc_policy' in settings.INSTALLED_APPS:
    # OpenID Connect Provider
    urlpatterns.extend([path('openid/', include('oidc_provider.urls', namespace='oidc_provider')),])


if settings.DEBUG:
    urlpatterns.extend(static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT))
    urlpatterns.extend([
        path('e/400/', TemplateView.as_view(template_name='400.html')),
        path('e/403/', TemplateView.as_view(template_name='403.html')),
        path('e/404/', TemplateView.as_view(template_name='404.html')),
        path('e/500/', TemplateView.as_view(template_name='500.html')),
    ])

prologin/qcm/urls.py
from django.urls import path

import qcm.views

app_name = 'qcm'

urlpatterns = [
    path('', qcm.views.DisplayQCMView.as_view(), name='display'),
]

prologin/team/urls.py
from django.urls import path

from team import views

app_name = 'team'

urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    path('<int:year>', views.IndexView.as_view(), name='year'),
]

prologin/users/urls.py
from django.urls import path, include
from users import views, auth_token_views

app_name = 'users'

user_patterns = [
    path('profile', views.ProfileView.as_view(), name='profile'),
    path('edit', views.EditUserView.as_view(), name='edit'),
    path('edit/password', views.EditPasswordView.as_view(), name='edit_password'),
    path('delete', views.DeleteUserView.as_view(), name='delete'),
    path('takeout', views.TakeoutDownloadUserView.as_view(), name='takeout'),

    # Homes
    path('home/<int:year>', views.DownloadFinalHomeView.as_view(), name='download-final-home'),

    # Impersonate (django-hijack)
    path('impersonate', views.ImpersonateView.as_view(), name='impersonate'),
]

auth_token_patterns = [
    path('authorize', auth_token_views.AuthorizeView.as_view(), name='token-authorize'),
    # Internal to Prologin server, access should be restricted to internal IPs by nginx
    path('token', auth_token_views.AccessTokenView.as_view(), name='token-access'),
    path('refresh', auth_token_views.RefreshTokenView.as_view(), name='token-refresh'),
]

urlpatterns = [
    # User profile, view and edit
    path('<int:pk>/', include(user_patterns)),

    # Auth token stuff
    path('auth/', include(auth_token_patterns)),

    # Login and logout
    path('login', views.LoginView.as_view(), name='login'),
    path('logout', views.LogoutView.as_view(), name='logout'),

    # Search
    path('search/suggest', views.UserSearchSuggestView.as_view(), name='search-suggest'),

    # Password reset
    path('password/reset/ask', views.PasswordResetView.as_view(), name='password_reset'),
    path('password/reset/confirm/<uidb64>/<token>',
         views.PasswordResetConfirmView.as_view(), name='password_reset_confirm'),

    # Register and activate views
    path('register', views.RegistrationView.as_view(), name='register'),
    path('activate/<slug>', views.ActivationView.as_view(), name='activate'),

    # Mailing unsubscribe
    path('unsubscribe', views.UnsubscribeView.as_view(), name='unsubscribe'),
]

prologin/prologin/models.py
from django.db import models
from django.utils.translation import ugettext_noop, ugettext_lazy as _

from prologin.utils import ChoiceEnum
from prologin.languages import Language


@ChoiceEnum.labels(str.capitalize)
class Gender(ChoiceEnum):
    male = 0
    female = 1
    ugettext_noop("Male")
    ugettext_noop("Female")


class BaseEnumField:
    def __init__(self, enum, *args, **kwargs):
        assert issubclass(enum, ChoiceEnum)
        kwargs['choices'] = enum.choices(empty_label=kwargs.pop('empty_label', None))
        self._enum = enum
        super().__init__(*args, **kwargs)

    def deconstruct(self):
        name, path, args, kwargs = super().deconstruct()
        return name, path, [self._enum] + args, kwargs


class EnumField(BaseEnumField, models.PositiveSmallIntegerField):
    pass


class TextEnumField(BaseEnumField, models.CharField):
    def __init__(self, *args, **kwargs):
        kwargs['max_length'] = 64
        super().__init__(*args, **kwargs)


def _enumfield_factory(basecls, enumcls, name, **fieldkwargs):
    def init(self, *args, **kwargs):
        defaults = dict(fieldkwargs)
        defaults.update(kwargs)
        basecls.__init__(self, enumcls, *args, **defaults)

    def deconstruct(self):
        name, path, args, kwargs = basecls.deconstruct(self)
        return name, path, args[1:], kwargs

    return type(name, (basecls,), {'__init__': init, 'deconstruct': deconstruct})


GenderField = _enumfield_factory(EnumField, Gender, 'GenderField',
                                 empty_label=_("Other or prefer not to tell"), verbose_name=_("Gender"))

CodingLanguageField = _enumfield_factory(TextEnumField, Language, 'CodingLanguageField',
                                         verbose_name=_("Coding language"))


class AddressableModel(models.Model):
    address = models.TextField(blank=True, verbose_name=_("Address"))
    postal_code = models.CharField(max_length=32, blank=True, verbose_name=_("Postal code"))
    city = models.CharField(max_length=64, blank=True, verbose_name=_("City"))
    country = models.CharField(max_length=64, blank=True, verbose_name=_("Country"))

    class Meta:
        abstract = True


class ContactModel(models.Model):
    contact_gender = GenderField(null=True, blank=True)
    contact_position = models.CharField(max_length=128, blank=True)
    contact_first_name = models.CharField(max_length=64, blank=True)
    contact_last_name = models.CharField(max_length=64, blank=True)
    contact_phone_desk = models.CharField(max_length=16, blank=True)
    contact_phone_mobile = models.CharField(max_length=16, blank=True)
    contact_phone_fax = models.CharField(max_length=16, blank=True)
    contact_email = models.EmailField(blank=True)

    def get_full_name(self):
        return " ".join(field for field in
                        (self.contact_first_name, self.contact_last_name) if field)

    class Meta:
        abstract = True

prologin/prologin/utils/models.py
import io
import os
import warnings
from PIL.Image import DecompressionBombWarning
from django.core.files import File
from django.db import models
from wand.exceptions import MissingDelegateError
from wand.image import Image


class ResizeOnSaveImageField(models.ImageField):
    def __init__(self, fit_into=None, *args, **kwargs):
        if isinstance(fit_into, int):
            fit_into = (fit_into, fit_into)
        elif len(fit_into) != 2:
            raise ValueError("fit_into must be an dimension or a pair of dimensions")
        assert fit_into[0] > 0 and fit_into[1] > 0
        self.fit_into = fit_into
        super().__init__(*args, **kwargs)

    def deconstruct(self):
        name, path, args, kwargs = super().deconstruct()
        kwargs['fit_into'] = self.fit_into
        return name, path, args, kwargs

    def pre_save(self, model_instance, add):
        file = super().pre_save(model_instance, add)
        if file:
            file.open()
            with warnings.catch_warnings():
                warnings.simplefilter("error", DecompressionBombWarning)
                try:
                    im = Image(file=file)
                except MissingDelegateError:
                    file.seek(0)
                    im = Image(file=file, format=os.path.splitext(file.name)[1].strip(os.path.extsep))
            file.close()
            im.transform(resize='{}x{}>'.format(*self.fit_into))
            buf = io.BytesIO()
            im.save(file=buf)
            file.save(file.name, File(buf, name=file.name), save=False)
        return file

prologin/prologin/utils/forms.py
from django import forms
from prologin.utils import _


class NewableModelChoiceField(forms.ModelChoiceField):
    def to_python(self, value):
        try:
            return super().to_python(value)
        except forms.ValidationError as exc:
            return self.create_new(self.queryset.model, value, exc)

    def create_new(self, model, value, exc):
        raise NotImplementedError()


class ConfirmDangerMixin(forms.Form):
    password_conf = forms.CharField(widget=forms.PasswordInput, label=_("Your current password"))

    def __init__(self, *args, **kwargs):
        # the user doing the dangerous operation, who must provide their password
        self.action_user = kwargs.pop('action_user')
        super().__init__(*args, **kwargs)

    def clean_password_conf(self):
        if not self.action_user.check_password(self.cleaned_data['password_conf']):
            raise forms.ValidationError(_("Wrong password."))

prologin/prologin/views.py
from django.core.exceptions import ImproperlyConfigured


class ChoiceGetAttrsMixin(object):
    """
    Mixin that handles a list of GET attributes that can be user-set to a predefined list of valid choices.
    Handles validation and fallback. User class has to use get_clean_attr('name') to access validated attributes.

    The list of attributes is get_attrs; you can also implement get_get_attrs().
    The first item of the choice list will be the default. You can use the None literal.

    Usage:

        class MyView(ChoiceGetAttrsMixin, View):
            get_attrs = {'sort': ['name', 'age', 'city'],
                         'order': ['asc', 'desc']}

            def some_method(self):
                sort = self.get_clean_attr('sort')
                ...
    """

    get_attrs = {}

    def get_get_attr(self):
        return self.get_attrs

    def get_clean_attr(self, attr):
        attrs = self.get_get_attr()
        try:
            choices = attrs[attr]
        except KeyError:
            raise KeyError("{} is not defined in get_attrs".format(attr))
        choices = list(choices)
        try:
            fallback = choices[0]
        except IndexError:
            raise ImproperlyConfigured("Attribute {} has an empty choice list".format(attr))
        value = self.request.GET.get(attr, fallback)
        if value not in choices:
            value = fallback
        return value

prologin/prologin/templates/prologin/favicons.html
{% load staticfiles %}

<link rel="apple-touch-icon" sizes="57x57" href="{% static 'img/apple-touch-icon-57.png' %}">
<link rel="apple-touch-icon" sizes="60x60" href="{% static 'img/apple-touch-icon-60.png' %}">
<link rel="apple-touch-icon" sizes="72x72" href="{% static 'img/apple-touch-icon-72.png' %}">
<link rel="apple-touch-icon" sizes="76x76" href="{% static 'img/apple-touch-icon-76.png' %}">
<link rel="apple-touch-icon" sizes="114x114" href="{% static 'img/apple-touch-icon-114.png' %}">
<link rel="apple-touch-icon" sizes="120x120" href="{% static 'img/apple-touch-icon-120.png' %}">
<link rel="apple-touch-icon" sizes="144x144" href="{% static 'img/apple-touch-icon-144.png' %}">
<link rel="apple-touch-icon" sizes="152x152" href="{% static 'img/apple-touch-icon-152.png' %}">
<link rel="apple-touch-icon" sizes="180x180" href="{% static 'img/apple-touch-icon-180.png' %}">
<link rel="icon" type="image/png" href="{% static 'img/favicon-16.png' %}" sizes="16x16">
<link rel="icon" type="image/png" href="{% static 'img/favicon-32.png' %}" sizes="32x32">
<link rel="icon" type="image/png" href="{% static 'img/favicon-96.png' %}" sizes="96x96">
<link rel="icon" type="image/png" href="{% static 'img/favicon-194.png' %}" sizes="194x194">
<link rel="manifest" href="/manifest.json">
<meta name="apple-mobile-web-app-title" content="Prologin">
<meta name="application-name" content="Prologin">
<meta name="msapplication-TileColor" content="#35479a">
<meta name="msapplication-TileImage" content="{% static 'img/mstile-144x144.png' %}">
<meta name="msapplication-config" content="/browserconfig.xml">
<meta name="theme-color" content="#35479a">

prologin/prologin/templates/prologin/main-footer.html
{% load i18n %}
{% load utils %}
{% load static %}

<div class="row">
  <div class="col-md-4">
    <h3>{% trans "Prologin" %}</h3>
    <ul class="nav">
      <li><a href="{% url 'pages:about-organization' %}"><i class="fa fa-cube fa-centered"></i> {% trans "The organization" %}</a></li>
      <li><a href="{% url 'pages:about-contribute' %}"><i class="fa fa-hand-paper-o fa-centered"></i> {% trans "Contribute" %}</a></li>
      <li><a href="{% url 'pages:about-organization' %}#contact"><i class="fa fa-envelope fa-centered"></i> {% trans "Contact us" %}</a></li>
      <li><a href="{% url 'pages:about-contest-rules' %}"><i class="fa fa-gavel fa-centered"></i> {% trans "Contest rules" %}</a></li>
      <li><a href="{% url 'pages:about-privacy-policy' %}"><i class="fa fa-lock fa-centered"></i> {% trans "Privacy policy" %}</a></li>
      <li><a href="{% url 'sponsors:index' %}"><i class="fa fa-heart fa-centered"></i> {% trans "Sponsors" %}</a></li>
      <li><a href="{% get_setting 'PROLOGIN_BUG_TRACKER_URL' %}"><i class="fa fa-bug"></i> {% trans "Report a bug on the website" %}</a></li>
      <li><a href="https://gitlab.com/prologin"><i class="fa fa-gitlab fa-centered"></i> Retrouvez nos projets libres sur notre GitLab</a></li>

    </ul>
        {% comment TODO %}
    <h3>{% trans "More" %}</h3>
    <ul class="nav">
      <li><a href="#TODO">{% trans "Press kit" %}</a></li>
    </ul>
        {% endcomment %}
  </div>
  <div class="col-md-4">
        {% comment TODO %}
    <h3>{% trans "Terms" %}</h3>
    <ul class="nav">
      <li><a href="#TODO">{% trans "Contest rules" %}</a></li>
    </ul>
        {% endcomment %}
    <h3>{% trans "Stay tuned!" %}</h3>
    {# social links #}
    <a href="https://discord.com/invite/fUKbkwU" title="{% trans "Prologin on Discord" %}" class="social">
      <span class="fa-stack fa-lg">
        <i class="fa fa-square-o fa-stack-2x fa-inverse"></i>
        <img src="{% static 'img/discord.svg' %}" class="fa-stack-1x fa-inverse fa" style="width: 20px;top: 12px;left: 11px;">
      </span>
    </a>
    <a href="https://www.instagram.com/association_prologin/" title="{% trans "Prologin on Instagram" %}" class="social">
      <span class="fa-stack fa-lg">
        <i class="fa fa-square-o fa-stack-2x fa-inverse"></i>
        <i class="fa fa-instagram fa-stack-1x fa-inverse"></i>
      </span>
    </a>
    <a href="https://www.facebook.com/prologin" title="{% trans "Prologin on Facebook" %}" class="social">
      <span class="fa-stack fa-lg">
        <i class="fa fa-square-o fa-stack-2x fa-inverse"></i>
        <i class="fa fa-facebook fa-stack-1x fa-inverse"></i>
      </span>
    </a>
    <a href="https://www.twitter.com/prologin" title="{% trans "Prologin on Twitter" %}" class="social">
      <span class="fa-stack fa-lg">
        <i class="fa fa-square-o fa-stack-2x fa-inverse"></i>
        <i class="fa fa-twitter fa-stack-1x fa-inverse"></i>
      </span>
    </a>
    <a href="https://www.linkedin.com/company/prologin/" title="{% trans "Prologin on LinkedIn" %}" class="social">
      <span class="fa-stack fa-lg">
        <i class="fa fa-square-o fa-stack-2x fa-inverse"></i>
        <i class="fa fa-linkedin fa-stack-1x fa-inverse"></i>
      </span>
    </a>
    <a href="https://www.tiktok.com/@assoprologin" title="{% trans "Prologin on TikTok" %}" class="social">
      <span class="fa-stack fa-lg">
        <i class="fa fa-square-o fa-stack-2x fa-inverse"></i>
        <img src="{% static 'img/tiktok.svg' %}" class="fa-stack-1x fa-inverse fa" style="width: 19px;top: 9px;left: 11px;">
      </span>
    </a>
    <a href="{% url 'zinnia:entry_feed' %}" title="{% trans "Prologin news Atom stream" %}" class="social">
      <span class="fa-stack fa-lg">
        <i class="fa fa-square-o fa-stack-2x fa-inverse"></i>
        <i class="fa fa-rss fa-stack-1x fa-inverse"></i>
      </span>
    </a>
  </div>
  <div class="col-md-4">
    <h3>{% trans "Change locale" %} <i class=" fa fa-globe"></i></h3>
    {% get_current_language as LANGUAGE_CODE %}
    <form action="{% url 'set_language' %}" method="post" id="change-lang-form" class="form-inline">
      {% csrf_token %}
      {# <input name="next" type="hidden" value="{{ redirect_to }}"/> #}
      <select name="language" id="set-language" class="form-control" onchange="$('#change-lang-form').submit();">
        {% get_available_languages as LANGUAGES %}
        {% get_language_info_list for LANGUAGES as languages %}
        {% for language in languages %}
          <option value="{{ language.code }}"{% if language.code == LANGUAGE_CODE %}
              selected="selected"{% endif %}>{{ language.name_local.title }}</option>
        {% endfor %}
      </select>
      <noscript><input type="submit" class="btn btn-default" value="{% trans "Apply" %}"/></noscript>
      {% if request.user.is_authenticated and LANGUAGE_CODE != request.user.preferred_locale %}
        {% url 'users:edit' request.user.pk as user_edit_url %}
        <p><small class="text-muted">{% blocktrans with url=user_edit_url %}Save your
preferred locale in your <a href="{{ url }}#id_preferred_locale">user settings</a>.{% endblocktrans %}</small></p>
      {% endif %}
    </form>
  </div>
</div>

prologin/prologin/templates/prologin/main-menu.html
{% load i18n %}
{% load navigation rules %}

<ul class="nav navbar-nav pull-right">
{% if request.current_events.qualification.is_active %}
  <li class="{% active '^/contest/' %}"><a href="{% url 'contest:qualification-summary' request.current_edition.year %}">{% trans "Participate" %}</a></li>
{% endif %}
  <li class="{% active '^/about/' %}"><a href="{% url 'pages:about-contest' %}">{% trans "Discover" %}</a></li>
  <li class="{% active '^/train/' %}"><a href="{% url 'problems:index' %}">{% trans "Train" %}</a></li>
  <li class="{% active '^/archives/' %}"><a href="{% url 'archives:index' %}">{% trans "Archives" %}</a></li>
  <li class="{% active '^/forum/' %}"><a href="{% url 'forum:index' %}">{% trans "Forums" %}</a></li>
{% if request.user.is_staff %}
  <li class="dropdown">
    <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false"><i class="fa fa-star"></i> {% trans "Admin" %} <span class="caret"></span></a>
    <ul class="dropdown-menu dropdown-menu-right" role="menu">
      <li><a href="{% url 'admin:index' %}">{% trans "Django administration" %}</a></li>
      <li class="divider"></li>
      {% has_perm 'correction.can_correct' request.user as can_correct %}
      {% if can_correct %}<li><a href="{% url 'contest:correction:index' %}"><i class="fa fa-fw fa-wrench"></i> {% trans "Correction" %}</a></li>{% endif %}
      {% has_perm 'documents.generate_batch_document' request.user as can_correct %}
      {% if can_correct %}<li><a href="{% url 'documents:index' %}"><i class="fa fa-fw fa-archive"></i> {% trans "Documents" %}</a></li>{% endif %}
      {% has_perm 'massmailer.admin' request.user as can_do_mailing %}
      {% if can_do_mailing %}<li><a href="{% url 'massmailer:dashboard' %}"><i class="fa fa-fw fa-envelope-o"></i> {% trans "Mailing" %}</a></li>{% endif %}
      <li><a href="https://docs.prologin.org/index.html"><i class="fa fa-fw fa-support"></i> {% trans "Documentation" %}</a></li>
      {% has_perm 'users.search' request.user as can_search %}
      {% if can_search %}
      <li>
        <form class="form-inline form-user-search">
          <i class="fa fa-fw fa-search"></i>
          <input type="hidden" id="search-user-id" name="user">
          <input id="search-user-name" name="username" type="text" autocomplete="off" class="form-control" placeholder="{% trans "Search users" %}">
        </form>
      </li>
      {% endif %}
    </ul>
  </li>
{% endif %}
  <li class="sep"><a>&nbsp;</a></li>
  {% if user.is_authenticated %}
  <li class="dropdown">
    <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false"><i class="fa fa-user"></i> {{ user.username }} <span class="caret"></span></a>
    <ul class="dropdown-menu dropdown-menu-right" role="menu">
      <li><a href="{% url 'users:profile' user.id %}"><i class="fa fa-user"></i> {% trans "My profile" %}</a></li>
      <li><a href="{% url 'users:edit' user.id %}"><i class="fa fa-cog"></i> {% trans "Profile &amp; settings" %}</a></li>
      <li class="divider"></li>
      <li><form method="post" action="{% url 'users:logout' %}">{% csrf_token %}<button type="submit"><i class="fa fa-power-off"></i> {% trans "Sign out" %}</button></form></li>
    </ul>
  </li>
  {% else %}
  <li class="{% active 'users:login' %}">
    <a href="{% url 'users:login' %}?{% querystring request next=request.path %}">{% trans "Sign in" %}</a>
  </li>
  <li class="{% active 'users:register' %}">
    <a href="{% url 'users:register' %}?{% querystring request next=request.path %}">{% trans "Register" %}</a>
  </li>
  {% endif %}
</ul>

prologin/prologin/templates/prologin/messages.html
{% load i18n %}

{% for message in messages %}

{% if 'modal' in message.extra_tags %}
<div class="modal fade" tabindex="-1" role="dialog" data-show="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-body">
        {{ message|safe }}
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">{% trans "Close" %}</button>
      </div>
    </div>
  </div>
</div>

{% else %}

{% if message.level == DEFAULT_MESSAGE_LEVELS.ERROR %}
<div class="alert alert-dismissable alert-danger">
  <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
  <i class="fa fa-times-circle"></i>
{% elif message.level == DEFAULT_MESSAGE_LEVELS.WARNING %}
<div class="alert alert-dismissable alert-warning">
  <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
  <i class="fa fa-exclamation-triangle"></i>
{% elif message.level == DEFAULT_MESSAGE_LEVELS.SUCCESS %}
<div class="alert alert-dismissable alert-success">
  <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
  <i class="fa fa-check-circle"></i>
{% else %}
<div class="alert alert-dismissable alert-info">
  <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
  <i class="fa fa-info-circle"></i>
{% endif %}
  <div>{{ message|safe }}</div>
</div>
{% endif %}
{% endfor %}